<?php

namespace HCM\FPA\Entity;

use HCM\Util\Repositories;
use HCM\Util\TkEntity;
use Zeedhi\Framework\ORM\DateTime;

class FpadepvinculoEntity extends TkEntity
{

    private $_nrOrg;
    private $_nrOrgPadrao;

    const IDUNIVERSITARIO_SIM = 'S';
    const IDUNIVERSITARIO_NAO = 'N';

   public function __construct($entityManager, $hcmParameters) {
        $this->hcmParameters = $hcmParameters;
        $this->_nrOrgPadrao = $hcmParameters->getNrorgPadrao();
        $this->_nrOrg = $hcmParameters->getNrorgTrabalho();
        
        parent::__construct(null,$entityManager);
    }

    public function carregaDependenciasPorVinculo($nr_vinculo) {
        $this->resetItems();
        
        $dependencias = $this->entityManager->getRepository(Repositories::FPA_DEPVINCULO)->findBy(
            array('nrvinculom' => $nr_vinculo, 'nrorg' =>  $this->_nrOrg), array('nrtipodepende' => 'ASC'));
        
        foreach ($dependencias as $dependencia){
            $this->addItem($dependencia);
        }
        
    }

    private function _atualizaDependentesVinculo(
        GpevinculomEntity $vinculo, FpatipodependeEntity $obj_tipo_dependencia, $nr_dependentes
    ) {
        if ($obj_tipo_dependencia->getIdatudepsalfam() === FpatipodependeEntity::IDATUDEPSALFAM_SIM) {
            $vinculo->historico->atualizaNrDependentesSalarioFamilia($nr_dependentes);
        }

        if ($obj_tipo_dependencia->getIdatudepirrf() === FpatipodependeEntity::IDATUDEPIRRF_SIM) {
            $vinculo->historico->atualizaNrDependentesImpostoRenda($nr_dependentes);
        }
    }

    public function insereDependenteVinculo($nrorg, $nrpessoa, $nrtipodepende, $nrfuncvinculom) {
        $this->setNrorg($nrorg);
        $this->setNrpessoa($nrpessoa);
        $this->setNrtipodepende($nrtipodepende);
        $this->setNrvinculom($nrfuncvinculom);
    }
}

