<?php

/**
 * User: ArturMarcos
 * Date: 18/08/18
 * Time: 13:10
 * To change this template use File | Settings | File Templates.
 */
 
namespace HCM\Geral\Logic\Apolo;


ini_set("memory_limit","2048M");

use HCM\Util\Repositories;
use HCM\Util\DateUtil;
use HCM\Util\FPA;
use HCM\Util\Messages;
use HCM\Util\MsgProcesso;
use HCM\Util\HCMParameters;
use HCM\Util\Mail\Mail;
use Zeedhi\Framework\Session\Session;
use Teknisa\Libs\Util\SMTP;
use HCM\Geral\Services\ESocialService;
use HCM\Geral\Services\EnviarEmailService;

class consumidorTransmissaoEsocial extends \Zeedhi\Queue\Consumer {

    const QUEUE_NAME = "hcm_transmissaoEsocial_";

	protected static $queueName = '/queue/';
    private $dsemailoper;
    private $cdoperador;
    private $dtmescompetencia;
    private $nrorg;
    private $nrFormulario;
    private $pid;
    private $corpoEmail;
    private $msg;
    
    public function __construct($hcmParameters, $eSocialService, $entityManager, $connection, $queueName){
        parent::__construct($connection);
        self::$queueName = $queueName;
        $this->pid = getmypid();
        $this->entityManager = $entityManager;
        $this->eSocialService = $eSocialService;
        $this->jenkins = true;
        $this->hcmParameters = $hcmParameters;
        $this->qtdMaxEventosLote = 50;
        $this->msg = array();
        $this->runAndFinish();
    }
    
	/**
     * @param string $message
     * @return void
     */
    public function consume($message) {
        
        // Tempo de execucao deve ser ilimitado.
        set_time_limit(0);
        error_reporting(E_ERROR | E_PARSE);
    	try {
            echo ">>>>>>>>>> Iniciando Processo <<<<<<<<<<".PHP_EOL;
            echo 'Pid = '.$this->pid.PHP_EOL;
            
            $consumerParams = json_decode($message, true)[0];
           
            //percorre parametros do Esocial para a organização passada.
            foreach($consumerParams as $nrorg => $parametrosEsocial){
                foreach($parametrosEsocial as $key => $parametro){
                    $eventos = $this->entityManager->getRepository(Repositories::ESO_EVENTO)->getEventosESocial($parametro['DSVERSAO']);
                    foreach($eventos as $key => $evento){
                        $row = array_merge($evento, $parametro);
                        $this->envioAutomaticoEventos($row);
                    }
                }
                echo "Enviado para a Org: $nrorg".PHP_EOL;
                
                if($this->msg){
                    $this->notificaTransmissao($nrorg);
                }
            }
            
           return array(true, $this->pid, array($this->pid));
           
        } catch (\Exception $e) {
            echo "Erro: ".$e->getMessage();
            $this->kill($this->pid);
            die();
        }
    }
    
    
    public function envioAutomaticoEventos($paramESocial) {
        try {
            /*LOG -*/
            $start = microtime(true);
            $this->eSocialService->saveLogESocial('=== envioAutomaticoEventos starts ===');
            /*- LOG*/
            
            $oldmask = umask(0);

            $nrEstruturam = $paramESocial['NRESTRUTURAM'];
            $nmEstruturam = $paramESocial['NMESTRUTURAM'];
            $nrEvento = $paramESocial['NREVENTO'];
            $nmEvento = $paramESocial['NMEVENTO'];
            $idGrupo = $paramESocial['IDGRUPO'];
            $idStatus = isset($paramESocial['IDSTATUS']) ? $paramESocial['IDSTATUS'] : null;
            $dtmescompetenc = $this->hcmParameters->getDtCompetencia();
            
            /*LOG -*/
            $this->eSocialService->saveLogESocial('envioAutomaticoEventos Estrutura:' . $nrEstruturam . ' Evento:' . $nmEvento);
            /*- LOG*/

            $dsVersao = str_replace('.','-',$paramESocial['DSVERSAO']);
            $nrtpambiente = $paramESocial['NRTPAMBIENTE'];

            /*LOG -*/
            $lap = microtime(true);
            /*- LOG*/
            // Busca os itens pendentes que serão enviados por evento
            $arrEnvios = $this->eSocialService->getEnviosParaEvento($nrEstruturam, $nrtpambiente, $nrEvento, ['P','E','R'], $dtmescompetenc, $idGrupo);
            if (empty($arrEnvios)) {
                echo $nmEstruturam.' - '.$nmEvento.' - Sem itens para envio'.PHP_EOL;
                return;
            }
            echo $nmEstruturam.' - '.$nmEvento.' - '.count($arrEnvios).' itens para envio'.PHP_EOL;
            /*LOG -*/
            $this->eSocialService->saveLogESocial(' > getEnviosParaEvento elapsed ' . $this->eSocialService->convertSecondsToTime(microtime(true) - $lap));
            /*- LOG*/

            /*LOG -*/
            $lap = microtime(true);
            /*- LOG*/
            $naoEnvia = $this->eSocialService->setDadosTransmissao($nrEstruturam, $this->jenkins);
            
            if(is_array($naoEnvia) && array_key_exists('ALERT', $naoEnvia)){
                if(!isset($this->msg[$nmEstruturam])) {
                    $this->msg[$nmEstruturam] = array(
                        'NRTPAMBIENTE' => $paramESocial['NRTPAMBIENTE'],
                        'DSVERSAO' => $paramESocial['DSVERSAO'],
                        'DSEMAILENVIO' => $paramESocial['DSEMAILENVIO'],
                        'EVENTOS' => array(),
                        'ALERTA' => array(),
                    );
                }
                if(!array_key_exists('CERTIFICADO', $this->msg[$nmEstruturam]['ALERTA'])){
                    $this->msg[$nmEstruturam]['ALERTA']['CERTIFICADO'] = $naoEnvia['ALERT'];
               }
            }else if(is_array($naoEnvia)){
                if(!isset($this->msg[$nmEstruturam])) {
                    $this->msg[$nmEstruturam] = array(
                        'NRTPAMBIENTE' => $paramESocial['NRTPAMBIENTE'],
                        'DSVERSAO' => $paramESocial['DSVERSAO'],
                        'DSEMAILENVIO' => $paramESocial['DSEMAILENVIO'],
                        'EVENTOS' => array(),
                        'ALERTA' => array(),
                    );
                }
                 
                $this->msg[$nmEstruturam]['EVENTOS'][$paramESocial['DSEVENTO']]['MSGERRO'] = $naoEnvia['MSG'];
                /*LOG -*/
                $this->eSocialService->saveLogESocial(' > setDadosTransmissao erro ' . $naoEnvia['MSG'], true);
                /*- LOG*/
                return;
            }
            
            /*LOG -*/
            $this->eSocialService->saveLogESocial(' > setDadosTransmissao elapsed ' . $this->eSocialService->convertSecondsToTime(microtime(true) - $lap));
            /*- LOG*/

            // Array que vai conter os lotes de eventos
            $eventosEnvio = array();
            $msgValidacao = array();

            /*LOG -*/
            $lap = microtime(true);
            /*- LOG*/
            try {
                $this->entityManager->beginTransaction();
                foreach($arrEnvios as $envio) {
                    $msgProcesso = MsgProcesso::getInstance($this->hcmParameters->getNrorg(), $this->hcmParameters->getCdoperador(), $envio->getNrenvio());
                    $dadosEnvio = $envio->toArray();
                    $dadosEnvio['NMEVENTO'] = $nmEvento;
                    $dadosEnvio['IDGRUPO'] = $idGrupo;
                    $dadosEnvio['DTMESCOMPETENC'] = $dadosEnvio['DTMESCOMPETENC']->format('d/m/Y H:i:s');
                    if($dadosEnvio['IDSTATUS'] == 'E' || $dadosEnvio['IDSTATUS'] == 'R'){
                        $this->eSocialService->deleteDadosEnvio($dadosEnvio);
                    }
    
                    /*LOG -*/
                    $lap1 = microtime(true);
                    /*- LOG*/
                    $xmlEvento = $this->eSocialService->getXmlEvento($dsVersao, $dadosEnvio);
                    /*LOG -*/
                    $this->eSocialService->saveLogESocial(' > getXmlEvento elapsed ' . $this->eSocialService->convertSecondsToTime(microtime(true) - $lap1));
                    /*- LOG*/
                    
                    if ($xmlEvento) {
                        echo $nmEstruturam.' - '.$nmEvento.' - Envio:'.$envio->getNrenvio().'/Chave:'.$envio->getNrchave().' incluído no lote'.PHP_EOL;
                        $eventosEnvio[$envio->getNrenvio()] = $xmlEvento;
                    }
                
                    foreach ($msgProcesso->getMessages() as $msg) {
                        $msgValidacao[] = array(
                            'NRENVIO' => $dadosEnvio['NRENVIO'],
                            'NMEVENTO' => $dadosEnvio['NMEVENTO'],
                            'NRCHAVE' => $dadosEnvio['NRCHAVE'],
                            'IDOPERACAO' => $dadosEnvio['IDOPERACAO'],
                            'NRTABELA' => $dadosEnvio['NRTABELA'],
                            'DTMESCOMPETENC' => $dadosEnvio['DTMESCOMPETENC'],
                            'MSG' => $msg['MSG'],
                            'TYPE' => $msg['TYPE'],
                        );
                    }
                    $msgProcesso->clear();
                    unset($msgProcesso);
                }
                $this->entityManager->flush();
                $this->entityManager->commit();
            } catch (\Exception $e) {
                $this->entityManager->rollback();
                throw $e;
            }
            /*LOG -*/
            $this->eSocialService->saveLogESocial(' > foreach.getXmlEvento (' . count($arrEnvios) . ' envios) elapsed ' . $this->eSocialService->convertSecondsToTime(microtime(true) - $lap), true);
            /*- LOG*/

            if (empty($eventosEnvio) && empty($msgValidacao)) {
                echo PHP_EOL.$nmEstruturam.' - '.$nmEvento.' - Sem itens para envio'.PHP_EOL;
                return;
            }
            
            //rotina automatica enviar mesmo com erro na pre-validação.
            if (count($msgValidacao) > 0) {
                
                if(!isset($this->msg[$nmEstruturam])) {
                    $this->msg[$nmEstruturam] = array(
                        'NRTPAMBIENTE' => $paramESocial['NRTPAMBIENTE'],
                        'DSVERSAO' => $paramESocial['DSVERSAO'],
                        'DSEMAILENVIO' => $paramESocial['DSEMAILENVIO'],
                        'EVENTOS' => array(),
                        'ALERTA' => array(),
                    );
                }
                
                $msgEnvio = array();
                foreach ($msgValidacao as $msg) {
                    $operacao = '';
                    if($msg["IDOPERACAO"] == 'I'){
                        $operacao = 'Inclusão';
                    }else if($msg["IDOPERACAO"] == 'A'){
                        $operacao = 'Alteração';
                    }else if($msg["IDOPERACAO"] == 'E'){
                        $operacao = 'Exclusão';
                    }else if($msg["IDOPERACAO"] == 'R'){
                        $operacao = 'Retificação';
                    }
                    
                    $tabela = '';
                    if($msg["NRTABELA"]){
                        $tabela = '<b>Tabela:</b> '.$paramESocial["NRTABELA"];
                    }
                    
                    $espaco = '<span>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp</span>';
                    $cabecalho =
                        '<b>Chave: '.$msg['NRCHAVE'].'</b><br>'.
                        '<b>Nr Envio:</b> '.$msg['NRENVIO'].$espaco.
                        '<b>Operação:</b> '.$operacao.$espaco.
                        ($tabela ? $tabela.$espaco : '').
                        '<b>Histórico:</b> '.DateUtil::getDataDeString($msg['DTMESCOMPETENC'],DateUtil::FORMATO_BRASILEIRO_DATAHORA,true)->format('d/m/Y');
                    
                    if(!isset($msgEnvio[$msg['NRENVIO']])){
                        $msgEnvio[$msg['NRENVIO']] = array(
                            'CABECALHO' => $cabecalho,
                            'MSG' => array(),
                        );
                    }
                        
                    $msgEnvio[$msg['NRENVIO']]['MSG'][] = $msg['MSG'];
                }
                $this->msg[$nmEstruturam]['EVENTOS'][$paramESocial['DSEVENTO']] = $msgEnvio;
            } 
            
            // Verificar se ocorreu erro em alguns dos lotes
            $idOcorreuErro = false;
            $arrCodErros = array(
                ESocialService::CD_RET_LOTE_301,
                ESocialService::CD_RET_LOTE_401,
                ESocialService::CD_RET_LOTE_402,
                ESocialService::CD_RET_LOTE_403,
                ESocialService::CD_RET_LOTE_404,
                ESocialService::CD_RET_LOTE_405,
            );

            //Separa os eventos em grupos na quantidade máxima de eventos por lote
            $arrEventosEnvio = array_chunk($eventosEnvio, $this->qtdMaxEventosLote, true);

            /*LOG -*/
            $lap = microtime(true);
            /*- LOG*/
            //Envia os lotes com os eventos
            foreach ($arrEventosEnvio as $eventos) {
                try {
                    //Transação a cada lote enviado para caso ocorra erro de conexão durante o envio de um dos lotes
                    $this->entityManager->beginTransaction();
                    
                    /*LOG -*/
                    $lap1 = microtime(true);
                    /*- LOG*/
                    
                    $param = $this->eSocialService->getParamESocial($nrEstruturam);
                    
                    $xmlLoteEmpregador = $this->eSocialService->getXmlLote($idGrupo, $param, $dsVersao, $eventos);
                    /*LOG -*/
                    $this->eSocialService->saveLogESocial(' >> getXmlLote (' . count($eventos) . ' eventos) elapsed ' . $this->eSocialService->convertSecondsToTime(microtime(true) - $lap1));
                    $lap1 = microtime(true);
                    /*- LOG*/
                    $retornoLote = $this->eSocialService->enviarLote($eventos, $xmlLoteEmpregador);
                    echo $nmEstruturam.' - '.$nmEvento.' - Lote enviado ('.count($eventos).' itens/Protocolo '.$retornoLote['REC'].')'.PHP_EOL;
                    /*LOG -*/
                    $this->eSocialService->saveLogESocial(' >> retornoLote [' . $retornoLote['COD'] . '-' . $retornoLote['MSG'] . '(' . $retornoLote['REC'] . ')]');
                    $this->eSocialService->saveLogESocial(' >> enviarLote elapsed ' . $this->eSocialService->convertSecondsToTime(microtime(true) - $lap1));
                    /*- LOG*/
                    if (array_search($retornoLote['COD'], $arrCodErros) != false) {
                        $idOcorreuErro = true;
                    }
                    
                    //Commit das alterações realizada nos envios do lote transmitido
                    $this->entityManager->flush();
                    $this->entityManager->commit();
                } catch (\Exception $e) {
                    $this->entityManager->rollback();
                    $this->eSocialService->saveLogESocial(' > exception.getXmlLote/enviarLote [' . $e->getMessage . ']');
                    throw $e;
                }
            
                //Delay para evitar erro de precedencia de envio de lotes em que um lote é enviado enquanto o anterior ainda está em processamento
                sleep(5);
            }
            /*LOG -*/
            $this->eSocialService->saveLogESocial(' > foreach.getXmlLote/enviarLote (' . count($arrEventosEnvio) . ' lotes) elapsed ' . $this->eSocialService->convertSecondsToTime(microtime(true) - $lap));
            /*- LOG*/

//                $this->entityManager->flush();
//                $this->entityManager->commit();
            umask($oldmask);

            /*if ($idOcorreuErro) {
                $response->addNotification(new DTO\Response\Notification('envioAutomaticoEventos', DTO\Response\Notification::TYPE_ALERT));
            } */
            
            
            /*LOG -*/
            $timeFromStart = microtime(true) - $start;
            $this->eSocialService->saveLogESocial('=== envioAutomaticoEventos ends elapsed ' . $this->eSocialService->convertSecondsToTime($timeFromStart), true);
            /*- LOG*/
        } catch(\Exception $e) {
            /*LOG -*/
            $timeFromStart = microtime(true) - $start;
            $this->eSocialService->saveLogESocial('=== envioAutomaticoEventos ends elapsed ' . $this->eSocialService->convertSecondsToTime($timeFromStart) . "(" . $e->getMessage() . ")", true);
            /*- LOG*/
            echo PHP_EOL.$nmEstruturam.' - '.$e->getMessage().PHP_EOL;
            return;
        }
    }
    
    public function notificaTransmissao($nrorg){
        
        foreach($this->msg as $nmEstruturam => $parametros){
            
            $nrtpambiente = $parametros['NRTPAMBIENTE'];
            $dsversao = $parametros['DSVERSAO'];
            $dsemailenvio = $parametros['DSEMAILENVIO'];
            
            $tpAmbiente = '';
                if($nrtpambiente == 1){
                    $tpAmbiente = 'Produção';
                }else if($nrtpambiente == 2){
                    $tpAmbiente = 'Produção restrita';
                }
            
            $corpo_msg = "
                <br><br><b>Versão:</b> ".$dsversao."
                <br><b>Ambiente:</b> ".$tpAmbiente;
                
            if(is_array($parametros['ALERTA']) && count($parametros['ALERTA']) > 0){
                $mensagemAlerta = '<br><br><b> Alertas ESocial: </b><br><br>';
                foreach($parametros['ALERTA'] as $alerta){
                    $mensagemAlerta .= $alerta.'<br>';
                }
                $corpo_msg .= $mensagemAlerta;
            }
            $corpo_msg .= "<br><b>Eventos:</b><br><br>";
            
            foreach($parametros['EVENTOS'] as $evento => $msg){
                $mensagemEvento = "<b>$evento</b><br><br>";
                
                foreach($msg as $chave => $envio){
                    if($chave == 'MSGERRO'){
                        if(array_key_exists($envio, $this->eSocialService->arrayMensagens)){
                            $envio = $this->eSocialService->arrayMensagens[$envio];
                        }
                        $mensagemEvento .= "$envio<br><br>";
                    }else{
                        $mensagemEvento .= $envio['CABECALHO']."<ul>";
                        foreach($envio['MSG'] as $mensagem){
                            $mensagemEvento .= "<li>$mensagem</li>";
                        }
                        $mensagemEvento .= "</ul><br>";
                    }
                }
                
                $corpo_msg .= $mensagemEvento;
                $mensagemEvento = '';
            }
            
            $dataAtual = DateUtil::getDataAtual()->format('d/m/Y H:i:s');   
            $assunto  = "Rotina Automática do e-Social - Transmissão - $dataAtual - $nmEstruturam";
            
            $mail = $this->hcmParameters->returnParamsSmtp(true);
            
            $emails = explode(';', $dsemailenvio);
            foreach ($emails as $email) {
                //verifica se ja foi mandado email para o mesmo email a ser enviado.
                $nome = explode('@',$email)[0];
            
                $content = array(
                    "SUBJECT"                 => $assunto,
                    "STRING_SUPERIOR_DIREITA" => "",
                    "CONTENT_BODY"            => $corpo_msg
                );
                
                $content = $this->template($corpo_msg);
                
                $de = 'Envio Automatico E-social';
                $send = $mail->newEmail(
                    $email,   //De/From
                    $content, //texto
                    $assunto, //assunto    
                    $nome,    //nome operador
                    $de,      //nome from
                    $email    //from
                );
                if($send === false){
                    echo 'Erro ao enviar email - '.$nmEstruturam.PHP_EOL;
                }
                        
            }
            
            $corpo_msg = '';
        }
    }
    
    public function template($corpo_msg){
       
       $corpo = <<<HTML
<table border="0" width="100%" cellpadding="0" cellspacing="0" bgcolor="eeeeee" style="background-color: #eeeeee"> 
    <tbody> 
        <tr> 
            <td> 
                <table border="0" align="center" width="590" cellpadding="0" cellspacing="0" bgcolor="0274BA" style="background-color: #0274ba ; text-align: center"> 
                    <tbody> 
                        <tr> 
                            <td> 
                                <table border="0" align="center" width="540" cellpadding="0" cellspacing="0"> 
                                    <tbody> 
                                        <tr> 
                                            <td align="center" valign="middle"> 
                                                <table border="0" align="middle" cellpadding="0" cellspacing="0" style="border-collapse: collapse"> 
                                                    <tbody> 
                                                        <tr> 
                                                            <td align="center" valign="middle"> 
                                                                <div style="color: #ffffff ; font-size: 25px ; padding: 35px ; font-family: &quot;verdana&quot; , sans-serif ; line-height: 24px">NOTIFICAÇÃO DO ESOCIAL
                                                                </div> 
                                                                <div style="color: #ffffff ; font-size: 16px ; font-family: &quot;verdana&quot; , sans-serif">
                                                                </div> 
                                                                <div style="color: #ffffff ; font-size: 16px ; font-family: &quot;verdana&quot; , sans-serif">
                                                                </div> 
                                                                <div style="color: #ffffff ; font-size: 16px ; font-family: &quot;verdana&quot; , sans-serif">
                                                                </div> 
                                                            </td> 
                                                        </tr> 
                                                    </tbody> 
                                                </table> 
                                            </td> 
                                        </tr> 
                                    </tbody> 
                                </table> 
                            </td> 
                        </tr> 
                    </tbody> 
                </table> 
            </td> 
        </tr> 
    </tbody> 
</table> 
<div> 
$corpo_msg
</b> 
</div> 
<table border="0" width="100%" cellpadding="0" cellspacing="0" bgcolor="eeeeee"> 
    <tbody> 
        <tr> 
            <td align="center"> 
                <table border="0" align="center" width="590" cellpadding="0" cellspacing="0" bgcolor="ffffff">
                    <div> 
                        <tbody> 
                            <tr> 
                                <td> 
                                    <table border="0" align="center" width="540" cellpadding="0" cellspacing="0"> 
                                        <tbody> 
                                            <tr> 
                                                <td align="left" style="color: #39434b ; font-size: 20px ; font-family: &quot;verdana&quot; , sans-serif">  
                                                    
                                                        <div>
                                                            <img src="https://www.teknisa.com/emails/img/rodape_3.png">
                                                              </div>
                                                                    </div> 
                                                                </td> 
                                                            </tr> 
                                                            <tr> 
                                                                <td height="10" style="font-size: 10px ; line-height: 10px"> 
                                                                </td> 
                                                            </tr> 
                                                        </tbody> 
                                                    </table> 
                                                </td> 
                                            </tr> 
                                        </tbody> 
                                    </div>
                                    <div>
                                        <br>
                                        </div>
                                    </table> 
                                </td> 
                            </tr> 
                        </tbody> 
                    </table> 
                    <table border="0" width="100%" cellpadding="0" cellspacing="0" bgcolor="eeeeee"> 
                        <tbody> 
                            <tr> 
                                <td> 
                                    <table border="0" align="center" width="590" cellpadding="0" cellspacing="0" bgcolor="#d8d8d8"> 
                                        <tbody> 
                                            <tr>
                                            </tr> 
                                            <tr>
                                            </tr> 
                                            <tr> 
                                                <td height="20" style="font-size: 20px ; line-height: 20px ; display: table"> 
                                                </td> 
                                            </tr> 
                                        </tbody> 
                                    </table> 
                                </td> 
                            </tr> 
                        </tbody> 
                    </table>
HTML;
    
        return $corpo;
    }
}