<?php
/** 
 * Created by PhpStorm.
 * User: felipesantos
 * Date: 08/08/2016
 * Time: 14:51
 */

namespace HCM\Geral\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\DateUtil;

class RelatorioCustomizavelRepository {

    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
    }

    public function retornaDadosValeTransporte($nrorgPadrao, $nrorg, $dtcompetencia, $tipohierarquia, $condEstrutLega, l$listaVinc, $condEstrutGeren, $conditions)
    {
        if($listaVinc) $listaVinc = " AND NRVINCULOM IN ($listaVinc)";
        else $listaVinc = "";

        $sql = "
SELECT * FROM (
        SELECT
			VAB_HISTVALEVINC.QTAPURVALE,
		  	VAB_HISTVALEVINC.QTDIASVALE,
		  	VAB_TARIFA.NRTARIFA,
			VAB_TARIFA.VRTARIFA,
		  	(VAB_TARIFA.VRTARIFA * VAB_HISTVALEVINC.QTAPURVALE * VAB_HISTVALEVINC.QTDIASVALE) AS TOTAL,
		  	SUBSTR(VAB_HISTVALEVINC.DTMESCOMPAPVALE,1,10) DTMESCOMPAPVALE,
		  	SUBSTR(VAB_HISTVALEVINC.DTPGTOVALE,1,10)      DTPGTOVALE,
		  	SUBSTR(VAB_HISTVALEVINC.DTINIAPURVALE,1,10)   DTINIAPURVALE,
		  	SUBSTR(VAB_HISTVALEVINC.DTFINAPURVALE,1,10)   DTFINAPURVALE,
		  	VAB_HISTVALEVINC.VRDEDUCAOVALE,
            VAB_HISTVALEVINC.NRLINHATRANSP,
            VAB_LINHA.DSLINHATRANSP,
		  	SENTIDOLINHA.NRSENTIDOLINHA,
		  	SENTIDOLINHA.DSSENTIDOLINHA,
		  	

		  	TIPOLINHAVINC.NRTIPOLINHAVINC,
		  	TIPOLINHAVINC.DSTIPOLINHAVINC,

		  	VINCULOH.NRESTRUTLEGAL,
		  	ESTRUTLEGALH.NMESTRUTURAH AS NMESTRUTLEGAL,
		  	VINCULOH.NRESTRUTGEREN,
		  	ESTRUTGERENCH.NMESTRUTURAH AS NMESTRUTGEREN,
		  	VINCULOH.NRESTRUTSIND,
		  	ESTRUTSINDH.NMESTRUTURAH AS NMESTRUTSIND,
		  	HIERARQUIAORG.NRTIPOHIERARQORG,
            ESTRUTSUPERIORM.NRESTRUTURAM AS NRESTRUTSUPERIOR,
            ESTRUTSUPERIORH.NMESTRUTURAH AS NMESTRUTSUPERIOR,
		  	GPE_VINCULOM.NRVINCULOM,
		  	GPE_VINCULOM.NMVINCULOM,
		  	GPE_VINCULOM.NRTIPOVINCULOM,
		  	GPE_VINCULOM.CDMATRICULA,
		  	GPE_VINCULOM.DTADMISSAOVINC,
            VINCULOH.NRCARGO,
            OCUPACAOH_CARGO.NMOCUPACAOH AS NMCARGO,
		  	GPE_TIPOVINCULOH.NMTIPOVINCULOH,
		  	GPE_PESSOAH.NRCPFPESSOA,
		  	GPE_PESSOAH.DTNASCPESSOA,
		  	GPE_PESSOAH.NRRGPESSOA,
		  	ESTRUTGERENCM.CDINTESTRUTEXP,
		  	BANCO.CDBANCO,
		  	BANCO.NMBANCO,
		  	CONTCORRPARC.CDAGENCIA,
		  	CONTCORRPARC.CDCONTCORR,

            PN_M.NMPRINCIPALPARC NMMAE, /*Nome da mãe*/

		  	VAB_INTEGTRANSPH.CDINTEGTRANSP,
            VAB_INTEGTRANSPH.NRMATRICULA AS CDMATINTEGTRANSP,

		  	FORNECEDOR.NRINSJURFORN,
		  	FORNECEDOR.NMFANTFORN,
		  	FORNECEDOR.NMRAZSOCFORN

		FROM VAB_HISTVALEVINC

        JOIN VAB_TARIFA
                 ON VAB_TARIFA.NRTARIFA = VAB_HISTVALEVINC.NRTARIFA

        JOIN SENTIDOLINHA
                 ON SENTIDOLINHA.NRSENTIDOLINHA = VAB_HISTVALEVINC.NRSENTIDOLINHA
                AND (SENTIDOLINHA.NRORG    = VAB_HISTVALEVINC.NRORG
                 OR SENTIDOLINHA.NRORG  = $nrorgPadrao)

        JOIN TIPOLINHAVINC
                 ON TIPOLINHAVINC.NRTIPOLINHAVINC = VAB_HISTVALEVINC.NRTIPOLINHAVINC
                AND (TIPOLINHAVINC.NRORG    = VAB_HISTVALEVINC.NRORG
                 OR TIPOLINHAVINC.NRORG  = $nrorgPadrao)

        JOIN VAB_LINHA
                 ON VAB_LINHA.NRLINHATRANSP = VAB_HISTVALEVINC.NRLINHATRANSP
                AND VAB_LINHA.NRORG = VAB_HISTVALEVINC.NRORG

        LEFT JOIN VAB_LINHAVINC
               ON VAB_LINHAVINC.NRORG = VAB_HISTVALEVINC.NRORG
              AND VAB_LINHAVINC.NRVINCULOM = VAB_HISTVALEVINC.NRVINCULOM
              AND VAB_LINHAVINC.NRLINHATARIFA = VAB_HISTVALEVINC.NRLINHATRANSP
              AND VAB_LINHAVINC.NRTIPOLINHAVINC = VAB_HISTVALEVINC.NRTIPOLINHAVINC
              AND VAB_LINHAVINC.NRSENTIDOLINHA = VAB_HISTVALEVINC.NRSENTIDOLINHA

        LEFT JOIN VAB_INTEGTRANSPH
               ON VAB_INTEGTRANSPH.NRORG = VAB_LINHAVINC.NRORG
              AND VAB_INTEGTRANSPH.NRINTEGTRANSPM = VAB_LINHAVINC.NRINTEGTRANSPM
              AND VAB_INTEGTRANSPH.NRTIPOLINHAVINC = VAB_LINHAVINC.NRTIPOLINHAVINC
              AND VAB_INTEGTRANSPH.DTMESCOMPINTEG = ( SELECT MAX(MAX_INTEGTRANSPH.DTMESCOMPINTEG)
                                                        FROM VAB_INTEGTRANSPH MAX_INTEGTRANSPH
                                                       WHERE VAB_INTEGTRANSPH.NRORG = MAX_INTEGTRANSPH.NRORG
                                                         AND VAB_INTEGTRANSPH.NRINTEGTRANSPM = MAX_INTEGTRANSPH.NRINTEGTRANSPM
                                                         AND MAX_INTEGTRANSPH.DTMESCOMPINTEG <= TO_DATE('$dtcompetencia', 'DD/MM/YYYY'))
                                                         
        JOIN FORNECEDOR
            ON (VAB_LINHA.CDFORNECED        = FORNECEDOR.CDFORNECED)
            AND (VAB_LINHA.NRORG            = $nrorg)
            AND FORNECEDOR.NRORG            = $nrorg

        JOIN GPE_VINCULOM
            ON (GPE_VINCULOM.NRORG         = VAB_HISTVALEVINC.NRORG
            AND GPE_VINCULOM.NRVINCULOM    = VAB_HISTVALEVINC.NRVINCULOM)
        JOIN GPE_VINCULOH VINCULOH
            ON (GPE_VINCULOM.NRORG           = VINCULOH.NRORG
           AND  GPE_VINCULOM.NRVINCULOM      = VINCULOH.NRVINCULOM)
           AND  VINCULOH.DTMESCOMPETENC =
               (SELECT MAX(DTMESCOMPETENC)
                        FROM GPE_VINCULOH
                        WHERE NRORG              = VINCULOH.NRORG
                            AND NRVINCULOM       = VINCULOH.NRVINCULOM
                            AND DTMESCOMPETENC <= TO_DATE('$dtcompetencia', 'DD/MM/YYYY'))
        LEFT JOIN GPE_TIPOVINCULOH
            ON ((GPE_TIPOVINCULOH.NRORG = GPE_VINCULOM.NRORG OR GPE_TIPOVINCULOH.NRORG = $nrorgPadrao)
           AND  GPE_TIPOVINCULOH.NRTIPOVINCULOM = GPE_VINCULOM.NRTIPOVINCULOM
		   AND  GPE_TIPOVINCULOH.DTMESCOMPETENC =
                                             (SELECT MAX(H1.DTMESCOMPETENC)
                                                FROM GPE_TIPOVINCULOH H1
                                               WHERE H1.NRORG          = GPE_TIPOVINCULOH.NRORG
                                                 AND H1.NRTIPOVINCULOM   = GPE_TIPOVINCULOH.NRTIPOVINCULOM
                                                 AND H1.DTMESCOMPETENC <= TO_DATE('$dtcompetencia', 'DD/MM/YYYY')))
        LEFT JOIN ESTRUTURAM ESTRUTLEGALM
            ON (VINCULOH.NRORG         = ESTRUTLEGALM.NRORG
           AND  VINCULOH.NRESTRUTLEGAL = ESTRUTLEGALM.NRESTRUTURAM)
        LEFT JOIN ESTRUTURAH ESTRUTLEGALH
            ON (ESTRUTLEGALM.NRORG        = ESTRUTLEGALH.NRORG
           AND  ESTRUTLEGALM.NRESTRUTURAM = ESTRUTLEGALH.NRESTRUTURAM
		   AND  ESTRUTLEGALH.DTMESCOMPETENC =
                                             (SELECT MAX(DTMESCOMPETENC)
                                                FROM ESTRUTURAH
                                               WHERE ESTRUTURAH.NRORG            = ESTRUTLEGALH.NRORG
                                                 AND ESTRUTURAH.NRESTRUTURAM       = ESTRUTLEGALH.NRESTRUTURAM
                                                 AND ESTRUTURAH.DTMESCOMPETENC <= TO_DATE('$dtcompetencia', 'DD/MM/YYYY')))
        LEFT JOIN ESTRUTURAM ESTRUTGERENCM
            ON (VINCULOH.NRORG         = ESTRUTGERENCM.NRORG
           AND  VINCULOH.NRESTRUTGEREN = ESTRUTGERENCM.NRESTRUTURAM)
        LEFT JOIN ESTRUTURAH ESTRUTGERENCH
            ON (ESTRUTGERENCM.NRORG        = ESTRUTGERENCH.NRORG
           AND  ESTRUTGERENCM.NRESTRUTURAM = ESTRUTGERENCH.NRESTRUTURAM)
		   AND  ESTRUTGERENCH.DTMESCOMPETENC =
                                             (SELECT MAX(DTMESCOMPETENC)
                                                FROM ESTRUTURAH
                                               WHERE ESTRUTURAH.NRORG            = ESTRUTGERENCH.NRORG
                                                 AND ESTRUTURAH.NRESTRUTURAM       = ESTRUTGERENCH.NRESTRUTURAM
                                                 AND ESTRUTURAH.DTMESCOMPETENC <= TO_DATE('$dtcompetencia', 'DD/MM/YYYY'))
        LEFT JOIN ESTRUTURAM ESTRUTSINDM
            ON (VINCULOH.NRORG         = ESTRUTSINDM.NRORG
           AND  VINCULOH.NRESTRUTSIND  = ESTRUTSINDM.NRESTRUTURAM)
        LEFT JOIN ESTRUTURAH ESTRUTSINDH
            ON (ESTRUTSINDM.NRORG        = ESTRUTSINDH.NRORG
           AND  ESTRUTSINDM.NRESTRUTURAM = ESTRUTSINDH.NRESTRUTURAM)
		   AND  ESTRUTSINDH.DTMESCOMPETENC =
                                             (SELECT MAX(DTMESCOMPETENC)
                                                FROM ESTRUTURAH
                                               WHERE ESTRUTURAH.NRORG            = ESTRUTSINDH.NRORG
                                                 AND ESTRUTURAH.NRESTRUTURAM       = ESTRUTSINDH.NRESTRUTURAM
                                                 AND ESTRUTURAH.DTMESCOMPETENC <= TO_DATE('$dtcompetencia', 'DD/MM/YYYY'))
        JOIN GPE_PESSOA
            ON GPE_VINCULOM.NRPESSOA = GPE_PESSOA.NRPESSOA
           AND GPE_VINCULOM.NRORG = GPE_PESSOA.NRORG

        JOIN GPE_PESSOAH
            ON GPE_PESSOAH.NRPESSOA = GPE_PESSOA.NRPESSOA
           AND GPE_PESSOAH.NRORG = GPE_PESSOA.NRORG
           AND GPE_PESSOAH.DTMESCOMPETENC = (SELECT MAX(MAX_PESSOAH.DTMESCOMPETENC)
                                               FROM GPE_PESSOAH MAX_PESSOAH
                                              WHERE MAX_PESSOAH.NRPESSOA = GPE_PESSOAH.NRPESSOA
                                                AND MAX_PESSOAH.NRORG = GPE_PESSOAH.NRORG
                                                AND MAX_PESSOAH.DTMESCOMPETENC <= TO_DATE('$dtcompetencia', 'DD/MM/YYYY'))

        /* OCUPACAO E FUNÇÃO */
        LEFT JOIN GPE_OCUPACAOM OCUPACAOM_CARGO
            ON VINCULOH.NRCARGO = OCUPACAOM_CARGO.NROCUPACAOM
            AND GPE_VINCULOM.NRORG = OCUPACAOM_CARGO.NRORG
        LEFT JOIN GPE_OCUPACAOH OCUPACAOH_CARGO
            ON OCUPACAOM_CARGO.NROCUPACAOM = OCUPACAOH_CARGO.NROCUPACAOM
            AND OCUPACAOM_CARGO.NRORG = OCUPACAOH_CARGO.NRORG
            AND OCUPACAOH_CARGO.DTMESCOMPETENC = (SELECT MAX(OCUPACAOH.DTMESCOMPETENC)
                                                FROM GPE_OCUPACAOH OCUPACAOH
                                               WHERE OCUPACAOH.NROCUPACAOM = OCUPACAOH_CARGO.NROCUPACAOM
                                                 AND OCUPACAOH.NRORG = OCUPACAOH_CARGO.NRORG
                                                 AND OCUPACAOH.DTMESCOMPETENC <= TO_DATE('$dtcompetencia', 'DD/MM/YYYY'))
                                                 
        /*Relacionamento - Nome da Mãe*/
        LEFT JOIN RELACIONAPARC RP_M ON RP_M.NRORG = GPE_PESSOA.NRORG
            AND RP_M.NRPARCNEGOCIO = GPE_PESSOA.NRPARCNEGOCIO
            AND RP_M.NRTIPORELACIONA = 1 /*Mãe*/
        LEFT JOIN PARCNEGOCIO PN_M ON PN_M.NRORG = RP_M.NRORG
            AND PN_M.NRPARCNEGOCIO = RP_M.NRPARCNEGRELAC
                                                 

                /* INFORMAÇÔES BANCÁRIAS*/
        LEFT JOIN CONTCORRPARC
               ON CONTCORRPARC.NRORG = GPE_VINCULOM.NRORG
              AND CONTCORRPARC.NRPARCNEGOCIO = GPE_PESSOA.NRPARCNEGOCIO
        LEFT JOIN BANCO
               ON BANCO.CDBANCO = CONTCORRPARC.CDBANCO
              AND (BANCO.NRORG = GPE_VINCULOM.NRORG OR BANCO.NRORG = $nrorgPadrao)
        LEFT JOIN AGENCIA
               ON AGENCIA.CDAGENCIA = CONTCORRPARC.CDAGENCIA
              AND AGENCIA.CDBANCO   = CONTCORRPARC.CDBANCO
              AND (AGENCIA.NRORG = GPE_VINCULOM.NRORG OR AGENCIA.NRORG = $nrorgPadrao)

        /*ESTRUTURA SUPERIOR*/
            LEFT JOIN HIERARQUIAORG
                   ON HIERARQUIAORG.NRESTRUTURAMREL  = VINCULOH.NRESTRUTGEREN
                  AND HIERARQUIAORG.NRORG            = GPE_VINCULOM.NRORG
                  $tipohierarquia
            LEFT JOIN ESTRUTURAM ESTRUTSUPERIORM
                   ON (ESTRUTSUPERIORM.NRORG         = VINCULOH.NRORG
                  AND  HIERARQUIAORG.NRESTRUTURAMSUP = ESTRUTSUPERIORM.NRESTRUTURAM)
            LEFT JOIN ESTRUTURAH ESTRUTSUPERIORH
                   ON (ESTRUTSUPERIORM.NRORG        = ESTRUTSUPERIORH.NRORG
                  AND  ESTRUTSUPERIORM.NRESTRUTURAM = ESTRUTSUPERIORH.NRESTRUTURAM)
                  AND  ESTRUTSUPERIORH.DTMESCOMPETENC =
                                                         (SELECT MAX(DTMESCOMPETENC)
                                                            FROM ESTRUTURAH
                                                           WHERE ESTRUTURAH.NRORG            = ESTRUTSUPERIORH.NRORG
                                                             AND ESTRUTURAH.NRESTRUTURAM       = ESTRUTSUPERIORH.NRESTRUTURAM
                                                             AND ESTRUTURAH.DTMESCOMPETENC <= TO_DATE('$dtcompetencia', 'DD/MM/YYYY'))


        WHERE VAB_HISTVALEVINC.NRORG           = $nrorg
		  AND VAB_HISTVALEVINC.DTMESCOMPAPVALE = TO_DATE('$dtcompetencia', 'DD/MM/YYYY')
		  $condEstrutLegal
		  $condEstrutGeren
		  AND (CONTCORRPARC.NRCONTCORRPARC = ( SELECT MAX(NRCONTCORRPARC) NRCONTCORRPARC
                                      FROM CONTCORRPARC C
                                     WHERE NRORG = GPE_PESSOA.NRORG
                                       AND NRPARCNEGOCIO = GPE_PESSOA.NRPARCNEGOCIO) or CONTCORRPARC.NRCONTCORRPARC IS NULL)
        )
 WHERE 1=1 $conditions  $listaVinc";

        $result = $this->connection->fetchAll($sql);
        return $result;
    }

    public function retornaDadosBeneficio($nrorgPadrao, $nrorg, $nrcalculobenef, $dtcompetencia, $tipohierarquia, $condEstrutLegal, $condEstrutGeren, $condRescisaoVinc,
                                          $condAtivacaoBeneficio, $condAtivacaoBeneficiario, $listaVinc, $conditions, $buttonFloatingSearch,
                                          $condListaEstrutLegal, $condListaEstrutGeren, $condListaEstrutSind, $condListaBeneficio, $condListaTpBeneficio, $condListaVinculo)
    {
        
        $proxCompetencia = DateUtil::getDataDeString( substr($dtcompetencia, 0, 10), DateUtil::FORMATO_BRASILEIRO, true );
        $proxCompetencia->add(new \DateInterval('P1M'));
        $proxCompetencia = $proxCompetencia->format('d/m/Y');
        
        if($listaVinc) $listaVinc = " AND NRVINCULOM IN ($listaVinc)";
        else $listaVinc = "";
        
        $sql = "

SELECT * FROM (
      SELECT
            GPE_VINCULOH.NRESTRUTLEGAL,
            ESTRUTLEGALH.NMESTRUTURAH AS NMESTRUTLEGAL,
            GPE_VINCULOH.NRESTRUTGEREN,
            ESTRUTGERENCH.NMESTRUTURAH AS NMESTRUTGEREN,
            GPE_VINCULOH.NRESTRUTSIND,
            ESTRUTSINDH.NMESTRUTURAH AS NMESTRUTSIND,
            HIERARQUIAORG.NRTIPOHIERARQORG,
            ESTRUTSUPERIORM.NRESTRUTURAM AS NRESTRUTSUPERIOR,
            ESTRUTSUPERIORH.NMESTRUTURAH AS NMESTRUTSUPERIOR,

            VAB_BENEFICIOM.NRBENEFICIOM,
            VAB_BENEFICIOH.TPPERIODOBENEF,
            VAB_BENEFICIOH.DSBENEFICIO,
            VAB_BENEFICIOH.NRMESANIVERSARIO,
            VAB_BENEFICIOH.NRDIAVENCBOLETO,
            VAB_BENEFICIOH.NRIDADEMAXSUBFILHOS,
            VAB_BENEFICIOH.NRIDADEMAXSUBDEP,
            VAB_BENEFICIOH.VRLINEARBENEFICIO,
            VAB_BENEFICIOH.VRLINEARBENEFICIODEP,
            VAB_BENEFICIOH.NRTIPOPARTICIPATITULAR,
            VAB_BENEFICIOH.VRPARTICIPATITULAR,
            VAB_BENEFICIOH.NRTIPOPARTICIPADEP,
            VAB_BENEFICIOH.VRPARTICIPADEPE,
            
            VAB_BENEFICIOM.DTINICIOVIGENCIA,
            VAB_BENEFICIOM.DTFINALVIGENCIA,
            
            EVH_MENS.NMEVENTOH AS NMEVENTOMENSA,
            EVH_MENS.NREVENTOM AS NREVENTOMENSA,
            EVH_MENS_DEP.NMEVENTOH AS NMEVENTOMENSADEP,
            EVH_MENS_DEP.NREVENTOM AS NREVENTOMENSADEP,
            EVH_EMP_TIT.NMEVENTOH AS NMEVETITULAREMP,
            EVH_EMP_TIT.NREVENTOM AS NREVETITULAREMP,
            EVH_EMP_DEP.NMEVENTOH AS NMEVEDEPEMPRESA,
            EVH_EMP_DEP.NREVENTOM AS NREVEDEPEMPRESA,
            EVH_TIT_VINC.NMEVENTOH AS NMEVETITULARVINC,
            EVH_TIT_VINC.NREVENTOM AS NREVETITULARVINC,
            EVH_DEP_VINC.NMEVENTOH AS NMEVEDEPEVINC,
            EVH_DEP_VINC.NREVENTOM AS NREVEDEPEVINC,
            
            (
                SELECT LISTAGG(TF_FAIXSAL_TIT.NRTABELAFOLHA, ', ') WITHIN  GROUP ( ORDER BY TF_FAIXSAL_TIT.NRTABELAFOLHA) 
                FROM FPA_TABELAFOLHA TF_FAIXSAL_TIT 
                WHERE INSTR( ', ' ||VAB_BENEFICIOH.NRTABFAIXASALTIT ||', ', ', ' ||TF_FAIXSAL_TIT.NRTABELAFOLHA ||', ') > 0 
                    AND (
                        TF_FAIXSAL_TIT.NRORG = VAB_BENEFICIOM.NRORG 
                        OR TF_FAIXSAL_TIT.NRORG = :NRORG_PADRAO 
                    ) 
            ) NRTABFAIXASALTIT,

            (
                SELECT LISTAGG(TF_FAIXSAL_TIT.NMTABELAFOLHA, ', ') WITHIN  GROUP ( ORDER BY TF_FAIXSAL_TIT.NMTABELAFOLHA) 
                FROM FPA_TABELAFOLHA TF_FAIXSAL_TIT 
                WHERE INSTR( ', ' ||VAB_BENEFICIOH.NRTABFAIXASALTIT ||', ', ', ' ||TF_FAIXSAL_TIT.NRTABELAFOLHA ||', ') > 0 
                    AND (
                        TF_FAIXSAL_TIT.NRORG = VAB_BENEFICIOM.NRORG 
                        OR TF_FAIXSAL_TIT.NRORG = :NRORG_PADRAO 
                    ) 
            ) NMTABFAIXASALTIT,
            
            (
                SELECT LISTAGG(TF_FAIXSAL_DEP.NRTABELAFOLHA, ', ') WITHIN  GROUP ( ORDER BY TF_FAIXSAL_DEP.NRTABELAFOLHA) 
                FROM FPA_TABELAFOLHA TF_FAIXSAL_DEP 
                WHERE INSTR( ', ' ||VAB_BENEFICIOH.NRTABFAIXASALDEP ||', ', ', ' ||TF_FAIXSAL_DEP.NRTABELAFOLHA ||', ') > 0 
                    AND (
                        TF_FAIXSAL_DEP.NRORG = VAB_BENEFICIOM.NRORG 
                        OR TF_FAIXSAL_DEP.NRORG = :NRORG_PADRAO 
                    ) 
            ) NRTABFAIXASALDEP,             

            (
                SELECT LISTAGG(TF_FAIXSAL_DEP.NMTABELAFOLHA, ', ') WITHIN  GROUP ( ORDER BY TF_FAIXSAL_DEP.NMTABELAFOLHA) 
                FROM FPA_TABELAFOLHA TF_FAIXSAL_DEP 
                WHERE INSTR( ', ' ||VAB_BENEFICIOH.NRTABFAIXASALDEP ||', ', ', ' ||TF_FAIXSAL_DEP.NRTABELAFOLHA ||', ') > 0 
                    AND (
                        TF_FAIXSAL_DEP.NRORG = VAB_BENEFICIOM.NRORG 
                        OR TF_FAIXSAL_DEP.NRORG = :NRORG_PADRAO 
                    ) 
            ) NMTABFAIXASALDEP,             
            
            TPBENEFICIO.NRTPBENEFICIO,
            TPBENEFICIO.DSTPBENEFICIO,

            FORMABENEFICIO.NRFORMABENEFICIO,
            FORMABENEFICIO.DSFORMABENEFICIO,

            GPE_VINCULOM.NRVINCULOM,
            GPE_VINCULOM.NMVINCULOM,
            GPE_VINCULOM.NRTIPOVINCULOM,
		  	GPE_VINCULOM.CDMATRICULA,
            GPE_TIPOVINCULOH.NMTIPOVINCULOH,
            GPE_PESSOAH.NRCPFPESSOA AS NRCPFVINCULO,
            GPE_PESSOAH.DTNASCPESSOA AS DTNASCIMENTOVINC,
            GPE_PESSOAH.IDSEXOPESSOA AS SEXOVINCULO,

            VAB_BENEFICIARIO.IDTPBENEFICIARIO, 
            VAB_BENEFICIARIO.NREVENTOM AS EVENTOBENEFICIARIO, 
            VAB_BENEFICIARIO.NRINSCBENEFICIARIO,
            
            PES_BENEFICIARIO.NMPESSOA AS NMBENEFICIARIO, 
            PES_BENEFICIARIO.DTNASCPESSOA AS DTNASCIMENTOBENEF,
            PES_BENEFICIARIO.NRCPFPESSOA AS NRCPFBENEFICIARIO,
            PES_BENEFICIARIO.IDSEXOPESSOA AS SEXOBENEFICIARIO,
            TIPORELACIONA.NMTIPORELACIONA,

            VAB_HISTBENEFVINC.NREVENTOM,
            SUBSTR(CF.DTOCORRENCIA,1,10) DTMESCOMPETENC,
            SUBSTR(VAB_HISTBENEFVINC.DTINIAPURBENEF,1,10) DTINIAPURBENEF,
            SUBSTR(VAB_HISTBENEFVINC.DTFINAPURBENEF,1,10) DTFINAPURBENEF,
            SUBSTR(VAB_HISTBENEFVINC.DTPGTOBENEF,1,10) DTPGTOBENEF,
            VAB_HISTBENEFVINC.QTAPURBENEF,
            VAB_HISTBENEFVINC.QTDIASBENEF,
            VAB_HISTBENEFVINC.QTDIASFALTAS,
            VAB_HISTBENEFVINC.QTDIASAFASTA,
            VAB_HISTBENEFVINC.QTDIASATESTADO,
            VAB_HISTBENEFVINC.QTDIASFERIAS,
            VAB_HISTBENEFVINC.QTDIASAVISO,
            VAB_HISTBENEFVINC.QTDIASDSR,
            VAB_HISTBENEFVINC.QTDIASFERIADO,
            VAB_HISTBENEFVINC.VRBENEFICIO AS VRBENEFICIODIARIO,
            VAB_HISTBENEFVINC.VRDEDUCAOBENEF,
            VAB_HISTBENEFVINC.VRTOTALBENEF AS VRTOTALBENEFDIARIO,

            ESTRUTGERENCM.CDINTESTRUTEXP,
            BANCO.CDBANCO,
            BANCO.NMBANCO,
            CONTCORRPARC.CDAGENCIA,
            CONTCORRPARC.CDCONTCORR,

            VAB_INTEGTRANSPH.CDINTEGTRANSP,
            VAB_INTEGTRANSPH.NRMATRICULA AS CDMATINTEGTRANSP,
            
		  	/*SITUAÇÃO FUNCIONAL*/
		  	GPE_ALTESITUFUNC.DTINISITUFUNC,
		  	GPE_ALTESITUFUNC.DTFIMSITUFUNC,
		  	GPE_SITUFUNCH.NMSITUFUNCH,
		  	GPE_SITUFUNCH.NRSITUFUNCM,  
            
			
		(SELECT 
		   SUM(VRAPURABENEFICIO)
          FROM VAB_APURABENEFICIO
		 WHERE VAB_APURABENEFICIO.NRORG         = VAB_BENEFICIOM.NRORG     			   
		   AND VAB_APURABENEFICIO.NRBENEFICIOM  = VAB_BENEFICIOM.NRBENEFICIOM
		   AND VAB_APURABENEFICIO.NRORG         = GPE_VINCULOM.NRORG				   
		   AND VAB_APURABENEFICIO.NRVINCULOM    = GPE_VINCULOM.NRVINCULOM
		   AND VAB_APURABENEFICIO.NRORG         = PES_BENEFICIARIO.NRORG				   				   
           AND VAB_APURABENEFICIO.NRPESSOA      = PES_BENEFICIARIO.NRPESSOA
		   AND VAB_APURABENEFICIO.NREVENTOM     IN (EVH_MENS.NREVENTOM, EVH_MENS_DEP.NREVENTOM)
		   AND VAB_APURABENEFICIO.NRCALCULOFOLHA = :NRCALCULOFOLHA
		 ) VALOR_MENSALIDADE,
													  
		(SELECT 
		   SUM(VRAPURABENEFICIO)
          FROM VAB_APURABENEFICIO
		 WHERE VAB_APURABENEFICIO.NRORG         = VAB_BENEFICIOM.NRORG     			   
		   AND VAB_APURABENEFICIO.NRBENEFICIOM  = VAB_BENEFICIOM.NRBENEFICIOM
		   AND VAB_APURABENEFICIO.NRORG         = GPE_VINCULOM.NRORG				   
		   AND VAB_APURABENEFICIO.NRVINCULOM    = GPE_VINCULOM.NRVINCULOM
		   AND VAB_APURABENEFICIO.NRORG         = PES_BENEFICIARIO.NRORG				   				   
           AND VAB_APURABENEFICIO.NRPESSOA      = PES_BENEFICIARIO.NRPESSOA
		   AND VAB_APURABENEFICIO.NREVENTOM     IN (EVH_EMP_TIT.NREVENTOM, EVH_EMP_DEP.NREVENTOM)
		   AND VAB_APURABENEFICIO.NRCALCULOFOLHA = :NRCALCULOFOLHA
		 ) VALOR_PARTE_EMPRESA,
													  
		(SELECT 
		   SUM(VRAPURABENEFICIO)
          FROM VAB_APURABENEFICIO
		 WHERE VAB_APURABENEFICIO.NRORG         = VAB_BENEFICIOM.NRORG     			   
		   AND VAB_APURABENEFICIO.NRBENEFICIOM  = VAB_BENEFICIOM.NRBENEFICIOM
		   AND VAB_APURABENEFICIO.NRORG         = GPE_VINCULOM.NRORG				   
		   AND VAB_APURABENEFICIO.NRVINCULOM    = GPE_VINCULOM.NRVINCULOM
		   AND VAB_APURABENEFICIO.NRORG         = PES_BENEFICIARIO.NRORG				   				   
           AND VAB_APURABENEFICIO.NRPESSOA      = PES_BENEFICIARIO.NRPESSOA
		   AND VAB_APURABENEFICIO.NREVENTOM     IN (EVH_TIT_VINC.NREVENTOM, EVH_DEP_VINC.NREVENTOM)
		   AND VAB_APURABENEFICIO.NRCALCULOFOLHA = :NRCALCULOFOLHA
		 ) VALOR_PARTE_FUNCIONARIO

        FROM VAB_BENEFICIOM

        JOIN VAB_BENEFICIOH
          ON VAB_BENEFICIOH.NRORG          = VAB_BENEFICIOM.NRORG
         AND VAB_BENEFICIOH.NRBENEFICIOM   = VAB_BENEFICIOM.NRBENEFICIOM
         AND VAB_BENEFICIOH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                                FROM VAB_BENEFICIOH VH2
                                               WHERE VH2.NRORG          = VAB_BENEFICIOH.NRORG
                                                 AND VH2.NRBENEFICIOM   = VAB_BENEFICIOH.NRBENEFICIOM
                                                 AND VH2.DTMESCOMPETENC <= TO_DATE(:DTMESCOMPETENC, 'DD/MM/YYYY'))

        JOIN TPBENEFICIO
          ON TPBENEFICIO.NRORG         = VAB_BENEFICIOH.NRORG
         AND TPBENEFICIO.NRTPBENEFICIO = VAB_BENEFICIOH.NRTPBENEFICIO
        
        JOIN FORMABENEFICIO
          ON FORMABENEFICIO.NRORG            = VAB_BENEFICIOH.NRORG
         AND FORMABENEFICIO.NRFORMABENEFICIO = VAB_BENEFICIOH.NRFORMABENEFICIO


        LEFT JOIN VAB_BENEFICIARIO
            ON VAB_BENEFICIARIO.NRORG          = VAB_BENEFICIOM.NRORG
             AND VAB_BENEFICIARIO.NRBENEFICIOM = VAB_BENEFICIOM.NRBENEFICIOM
             
        LEFT JOIN VAB_BENEFICIOM
            ON VAB_BENEFICIOM.NRBENEFICIOM     = VAB_BENEFICIARIO.NRBENEFICIOM
            AND VAB_BENEFICIOM.NRORG           = VAB_BENEFICIARIO.NRORG

        LEFT JOIN VAB_HISTBENEFVINC
            ON VAB_HISTBENEFVINC.NRORG             = VAB_BENEFICIOM.NRORG
             AND VAB_HISTBENEFVINC.NRBENEFICIOM    = VAB_BENEFICIOM.NRBENEFICIOM
             AND VAB_HISTBENEFVINC.NRVINCULOM      = VAB_BENEFICIARIO.NRVINCULOM 
             AND VAB_HISTBENEFVINC.DTMESCOMPETENC  = TO_DATE(:DTMESCOMPETENC, 'DD/MM/YYYY')

        JOIN GPE_PESSOAH PES_BENEFICIARIO 
            ON PES_BENEFICIARIO.NRPESSOA = VAB_BENEFICIARIO.NRPESSOA
                AND PES_BENEFICIARIO.NRORG = VAB_BENEFICIARIO.NRORG
                AND PES_BENEFICIARIO.DTMESCOMPETENC = (SELECT MAX(PSAH.DTMESCOMPETENC)
                                                        FROM GPE_PESSOAH PSAH
                                                       WHERE PSAH.NRORG = PES_BENEFICIARIO.NRORG
                                                         AND PSAH.NRPESSOA = PES_BENEFICIARIO.NRPESSOA
                                                         AND PSAH.DTMESCOMPETENC <= TO_DATE(:DTMESCOMPETENC, 'DD/MM/YYYY')
                                                      )

        JOIN GPE_VINCULOM
            ON GPE_VINCULOM.NRORG        = VAB_BENEFICIARIO.NRORG
             AND GPE_VINCULOM.NRVINCULOM = VAB_BENEFICIARIO.NRVINCULOM

        JOIN GPE_VINCULOH
            ON GPE_VINCULOH.NRORG            = GPE_VINCULOM.NRORG
             AND GPE_VINCULOH.NRVINCULOM     = GPE_VINCULOM.NRVINCULOM
             AND GPE_VINCULOH.DTMESCOMPETENC = (SELECT MAX(H1.DTMESCOMPETENC)
                                                  FROM GPE_VINCULOH H1
                                                 WHERE H1.NRORG           = GPE_VINCULOH.NRORG
                                                   AND H1.NRVINCULOM      = GPE_VINCULOH.NRVINCULOM
                                                   AND H1.DTMESCOMPETENC <= TO_DATE(:DTMESCOMPETENC, 'DD/MM/YYYY'))
            
        JOIN GPE_PESSOA
            ON GPE_VINCULOM.NRPESSOA = GPE_PESSOA.NRPESSOA
             AND GPE_VINCULOM.NRORG  = GPE_PESSOA.NRORG
        
        JOIN GPE_PESSOAH
            ON GPE_PESSOAH.NRPESSOA         = GPE_PESSOA.NRPESSOA
             AND GPE_PESSOAH.NRORG          = GPE_PESSOA.NRORG
             AND GPE_PESSOAH.DTMESCOMPETENC = (SELECT MAX(MAX_PESSOAH.DTMESCOMPETENC)
                                                 FROM GPE_PESSOAH MAX_PESSOAH
                                                WHERE MAX_PESSOAH.NRPESSOA       = GPE_PESSOAH.NRPESSOA
                                                  AND MAX_PESSOAH.NRORG          = GPE_PESSOAH.NRORG
                                                  AND MAX_PESSOAH.DTMESCOMPETENC <= TO_DATE(:DTMESCOMPETENC, 'DD/MM/YYYY'))
        
        /*Relacionamento entre o vínculo e o dependente (parentesco) - rafael pickbrenner pck 30/05/2018 140264 - [HCM] - Customizável - Benefício*/
        LEFT JOIN RELACIONAPARC ON RELACIONAPARC.NRORG          = GPE_PESSOA.NRORG
                               AND RELACIONAPARC.NRPARCNEGOCIO  = GPE_PESSOA.NRPARCNEGOCIO
                               AND RELACIONAPARC.NRPARCNEGRELAC = ( SELECT P.NRPARCNEGOCIO FROM GPE_PESSOA P
                                                                    WHERE P.NRORG    = GPE_PESSOA.NRORG
                                                                      AND P.NRPESSOA = PES_BENEFICIARIO.NRPESSOA )
        LEFT JOIN TIPORELACIONA ON TIPORELACIONA.NRORG IN (0, GPE_PESSOA.NRORG)
                               AND TIPORELACIONA.NRTIPORELACIONA = RELACIONAPARC.NRTIPORELACIONA
                               
        JOIN GPE_TIPOVINCULOH
            ON (GPE_TIPOVINCULOH.NRORG = GPE_VINCULOM.NRORG OR GPE_TIPOVINCULOH.NRORG = :NRORG_PADRAO)
             AND GPE_TIPOVINCULOH.NRTIPOVINCULOM = GPE_VINCULOM.NRTIPOVINCULOM
             AND GPE_TIPOVINCULOH.DTMESCOMPETENC = (SELECT MAX(H1.DTMESCOMPETENC)
                                                  FROM GPE_TIPOVINCULOH H1
                                                 WHERE H1.NRORG          = GPE_TIPOVINCULOH.NRORG
                                                   AND H1.NRTIPOVINCULOM = GPE_TIPOVINCULOH.NRTIPOVINCULOM
                                                   AND H1.DTMESCOMPETENC <= TO_DATE(:DTMESCOMPETENC, 'DD/MM/YYYY'))

        LEFT JOIN ESTRUTURAM ESTRUTLEGALM
            ON (GPE_VINCULOH.NRORG           = ESTRUTLEGALM.NRORG
             AND  GPE_VINCULOH.NRESTRUTLEGAL = ESTRUTLEGALM.NRESTRUTURAM)
        
        LEFT JOIN ESTRUTURAH ESTRUTLEGALH
            ON (ESTRUTLEGALM.NRORG            = ESTRUTLEGALH.NRORG
             AND  ESTRUTLEGALM.NRESTRUTURAM   = ESTRUTLEGALH.NRESTRUTURAM
             AND  ESTRUTLEGALH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                                   FROM ESTRUTURAH
                                                  WHERE ESTRUTURAH.NRORG          = ESTRUTLEGALH.NRORG
                                                    AND ESTRUTURAH.NRESTRUTURAM   = ESTRUTLEGALH.NRESTRUTURAM
                                                    AND ESTRUTURAH.DTMESCOMPETENC <= TO_DATE(:DTMESCOMPETENC, 'DD/MM/YYYY')))
        
        LEFT JOIN ESTRUTURAM ESTRUTGERENCM
            ON (GPE_VINCULOH.NRORG           = ESTRUTGERENCM.NRORG
             AND  GPE_VINCULOH.NRESTRUTGEREN = ESTRUTGERENCM.NRESTRUTURAM)
        
        LEFT JOIN ESTRUTURAH ESTRUTGERENCH
            ON (ESTRUTGERENCM.NRORG            = ESTRUTGERENCH.NRORG
             AND  ESTRUTGERENCM.NRESTRUTURAM   = ESTRUTGERENCH.NRESTRUTURAM)
             AND  ESTRUTGERENCH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                                    FROM ESTRUTURAH
                                                   WHERE ESTRUTURAH.NRORG          = ESTRUTGERENCH.NRORG
                                                     AND ESTRUTURAH.NRESTRUTURAM   = ESTRUTGERENCH.NRESTRUTURAM
                                                     AND ESTRUTURAH.DTMESCOMPETENC <= TO_DATE(:DTMESCOMPETENC, 'DD/MM/YYYY'))
        
        LEFT JOIN ESTRUTURAM ESTRUTSINDM
             ON (GPE_VINCULOH.NRORG         = ESTRUTSINDM.NRORG
             AND  GPE_VINCULOH.NRESTRUTSIND = ESTRUTSINDM.NRESTRUTURAM)
        
        LEFT JOIN ESTRUTURAH ESTRUTSINDH
            ON (ESTRUTSINDM.NRORG            = ESTRUTSINDH.NRORG
             AND  ESTRUTSINDM.NRESTRUTURAM   = ESTRUTSINDH.NRESTRUTURAM)
             AND  ESTRUTSINDH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                                  FROM ESTRUTURAH
                                                 WHERE ESTRUTURAH.NRORG          = ESTRUTSINDH.NRORG
                                                   AND ESTRUTURAH.NRESTRUTURAM   = ESTRUTSINDH.NRESTRUTURAM
                                                   AND ESTRUTURAH.DTMESCOMPETENC <= TO_DATE(:DTMESCOMPETENC, 'DD/MM/YYYY'))

        LEFT JOIN VAB_INTEGTRANSPH
            ON VAB_INTEGTRANSPH.NRORG = VAB_BENEFICIARIO.NRORG
             AND VAB_INTEGTRANSPH.NRINTEGTRANSPM = VAB_BENEFICIARIO.NRINTEGTRANSPM
             AND VAB_INTEGTRANSPH.DTMESCOMPINTEG = ( SELECT MAX(MAX_INTEGTRANSPH.DTMESCOMPINTEG)
                                                   FROM VAB_INTEGTRANSPH MAX_INTEGTRANSPH
                                                  WHERE VAB_INTEGTRANSPH.NRORG          = MAX_INTEGTRANSPH.NRORG
                                                    AND VAB_INTEGTRANSPH.NRINTEGTRANSPM = MAX_INTEGTRANSPH.NRINTEGTRANSPM
                                                    AND MAX_INTEGTRANSPH.DTMESCOMPINTEG <= TO_DATE(:DTMESCOMPETENC, 'DD/MM/YYYY'))

        /* INFORMAÇÕES BANCÁRIAS */
        LEFT JOIN CONTCORRPARC
            ON CONTCORRPARC.NRORG           = GPE_VINCULOM.NRORG
             AND CONTCORRPARC.NRPARCNEGOCIO = GPE_PESSOA.NRPARCNEGOCIO
        
        LEFT JOIN BANCO
            ON BANCO.CDBANCO  = CONTCORRPARC.CDBANCO
             AND (BANCO.NRORG = GPE_VINCULOM.NRORG OR BANCO.NRORG = :NRORG_PADRAO)
        
        LEFT JOIN AGENCIA
            ON AGENCIA.CDAGENCIA = CONTCORRPARC.CDAGENCIA
             AND AGENCIA.CDBANCO = CONTCORRPARC.CDBANCO
             AND (AGENCIA.NRORG  = GPE_VINCULOM.NRORG OR AGENCIA.NRORG = :NRORG_PADRAO)

        /*ESTRUTURA SUPERIOR*/
        LEFT JOIN HIERARQUIAORG
            ON HIERARQUIAORG.NRESTRUTURAMREL  = GPE_VINCULOH.NRESTRUTGEREN
             AND HIERARQUIAORG.NRORG          = GPE_VINCULOM.NRORG
             $tipohierarquia
        
        LEFT JOIN ESTRUTURAM ESTRUTSUPERIORM
            ON (GPE_VINCULOH.NRORG              = ESTRUTSUPERIORM.NRORG
             AND  HIERARQUIAORG.NRESTRUTURAMSUP = ESTRUTSUPERIORM.NRESTRUTURAM)
        
        LEFT JOIN ESTRUTURAH ESTRUTSUPERIORH
            ON (ESTRUTSUPERIORM.NRORG            = ESTRUTSUPERIORH.NRORG
             AND  ESTRUTSUPERIORM.NRESTRUTURAM   = ESTRUTSUPERIORH.NRESTRUTURAM)
             AND  ESTRUTSUPERIORH.DTMESCOMPETENC =
                                                     (SELECT MAX(DTMESCOMPETENC)
                                                        FROM ESTRUTURAH
                                                       WHERE ESTRUTURAH.NRORG            = ESTRUTSUPERIORH.NRORG
                                                         AND ESTRUTURAH.NRESTRUTURAM       = ESTRUTSUPERIORH.NRESTRUTURAM
                                                         AND ESTRUTURAH.DTMESCOMPETENC <= TO_DATE(:DTMESCOMPETENC, 'DD/MM/YYYY'))
    
    
    /* INFORMAÃƒâ€¡Ãƒâ€¢ES SOBRE OS EVENTOS DOS BENEFÃƒï¿½CIOS */
    
  
    LEFT JOIN
        FPA_EVENTOH EVH_MENS 
            ON(
                EVH_MENS.NREVENTOM = VAB_BENEFICIOH.NREVENTOMENSA 
                AND EVH_MENS.DTMESCOMPETENC = (
                                                    SELECT
                                                        MAX(SUB_EVENTH.DTMESCOMPETENC) 
                                                FROM
                                                    FPA_EVENTOH SUB_EVENTH 
                                                WHERE
                                                    SUB_EVENTH.NRORG              = EVH_MENS.NRORG 
                                                    AND SUB_EVENTH.DTMESCOMPETENC <= :DTMESCOMPETENC 
                                                    AND SUB_EVENTH.NREVENTOM      = EVH_MENS.NREVENTOM 
                                              ) 
                AND (
                    EVH_MENS.NRORG    = VAB_BENEFICIOM.NRORG 
                    OR EVH_MENS.NRORG = :NRORG_PADRAO 
                )
            )    
                                              
    
    LEFT JOIN
        FPA_EVENTOH EVH_MENS_DEP 
            ON(
                EVH_MENS_DEP.NREVENTOM          = VAB_BENEFICIOH.NREVENTOMENSADEP 
                AND EVH_MENS_DEP.DTMESCOMPETENC = (
                                                        SELECT
                                                            MAX(SUB_EVENTH.DTMESCOMPETENC) 
                                                    FROM
                                                        FPA_EVENTOH SUB_EVENTH 
                                                    WHERE
                                                        SUB_EVENTH.NRORG              = EVH_MENS_DEP.NRORG 
                                                        AND SUB_EVENTH.DTMESCOMPETENC <= :DTMESCOMPETENC 
                                                        AND SUB_EVENTH.NREVENTOM      = EVH_MENS_DEP.NREVENTOM 
                                                  ) 
                AND (
                    EVH_MENS_DEP.NRORG    = VAB_BENEFICIOM.NRORG 
                    OR EVH_MENS_DEP.NRORG = :NRORG_PADRAO 
                ) 
            ) 

        LEFT JOIN
            FPA_EVENTOH EVH_EMP_TIT 
                ON (
                    EVH_EMP_TIT.NREVENTOM          = VAB_BENEFICIOH.NREVETITULAREMP 
                    AND EVH_EMP_TIT.DTMESCOMPETENC = (
                                                        SELECT
                                                            MAX(SUB_EVENTH.DTMESCOMPETENC) 
                                                    FROM
                                                        FPA_EVENTOH SUB_EVENTH 
                                                    WHERE
                                                        SUB_EVENTH.NRORG              = EVH_EMP_TIT.NRORG 
                                                        AND SUB_EVENTH.DTMESCOMPETENC <= TO_DATE(:DTMESCOMPETENC, 'DD/MM/YYYY')
                                                        AND SUB_EVENTH.NREVENTOM      = EVH_EMP_TIT.NREVENTOM 
                                                    ) 
                    AND (
                        EVH_EMP_TIT.NRORG    = VAB_BENEFICIOM.NRORG 
                        OR EVH_EMP_TIT.NRORG = :NRORG_PADRAO 
                    ) 
                ) 
 
        LEFT JOIN
            FPA_EVENTOH EVH_EMP_DEP 
                ON(
                    EVH_EMP_DEP.NREVENTOM = VAB_BENEFICIOH.NREVEDEPEMPRESA 
                    AND EVH_EMP_DEP.DTMESCOMPETENC = (
                                                        SELECT
                                                            MAX(SUB_EVENTH.DTMESCOMPETENC) 
                                                    FROM
                                                        FPA_EVENTOH SUB_EVENTH 
                                                    WHERE
                                                        SUB_EVENTH.NRORG              = EVH_EMP_DEP.NRORG 
                                                        AND SUB_EVENTH.DTMESCOMPETENC <= TO_DATE(:DTMESCOMPETENC, 'DD/MM/YYYY')
                                                        AND SUB_EVENTH.NREVENTOM      = EVH_EMP_DEP.NREVENTOM 
                ) 
                AND (
                    EVH_EMP_DEP.NRORG    = VAB_BENEFICIOM.NRORG 
                    OR EVH_EMP_DEP.NRORG = :NRORG_PADRAO 
                ) 
            ) 
 
        LEFT JOIN
            FPA_EVENTOH EVH_TIT_VINC 
                ON(
                    EVH_TIT_VINC.NREVENTOM          = VAB_BENEFICIOH.NREVETITULARVINC 
                    AND EVH_TIT_VINC.DTMESCOMPETENC = (
                                                        SELECT
                                                            MAX(SUB_EVENTH.DTMESCOMPETENC) 
                                                    FROM
                                                        FPA_EVENTOH SUB_EVENTH 
                                                    WHERE
                                                        SUB_EVENTH.NRORG              = EVH_TIT_VINC.NRORG 
                                                        AND SUB_EVENTH.DTMESCOMPETENC <= TO_DATE(:DTMESCOMPETENC, 'DD/MM/YYYY')
                                                        AND SUB_EVENTH.NREVENTOM      = EVH_TIT_VINC.NREVENTOM 
                                                    ) 
                    AND (
                        EVH_TIT_VINC.NRORG    = VAB_BENEFICIOM.NRORG 
                        OR EVH_TIT_VINC.NRORG = :NRORG_PADRAO 
                    ) 
                ) 
 
        LEFT JOIN
            FPA_EVENTOH EVH_DEP_VINC 
                ON(
                    EVH_DEP_VINC.NREVENTOM          = VAB_BENEFICIOH.NREVEDEPEVINC 
                    AND EVH_DEP_VINC.DTMESCOMPETENC = (
                                                        SELECT
                                                            MAX(SUB_EVENTH.DTMESCOMPETENC) 
                                                    FROM
                                                        FPA_EVENTOH SUB_EVENTH 
                                                     WHERE
                                                        SUB_EVENTH.NRORG              = EVH_DEP_VINC.NRORG 
                                                        AND SUB_EVENTH.DTMESCOMPETENC <= TO_DATE(:DTMESCOMPETENC, 'DD/MM/YYYY')
                                                        AND SUB_EVENTH.NREVENTOM      = EVH_DEP_VINC.NREVENTOM 
                                                    ) 
                    AND (
                        EVH_DEP_VINC.NRORG    = VAB_BENEFICIOM.NRORG 
                        OR EVH_DEP_VINC.NRORG = :NRORG_PADRAO 
                    ) 
                )


            /* SITUAÇÃO FUNCIONAL*/
            LEFT JOIN GPE_ALTESITUFUNC
                    ON GPE_ALTESITUFUNC.NRVINCULOM = GPE_VINCULOM.NRVINCULOM
                   AND GPE_ALTESITUFUNC.NRORG = GPE_VINCULOM.NRORG
                   AND GPE_ALTESITUFUNC.NRSITUFUNCM <> 12
                   AND GPE_ALTESITUFUNC.DTINISITUFUNC = (SELECT MAX(MAX_ALTESITUFUNC.DTINISITUFUNC)
                                                        FROM GPE_ALTESITUFUNC MAX_ALTESITUFUNC
                                                       WHERE MAX_ALTESITUFUNC.NRVINCULOM = GPE_ALTESITUFUNC.NRVINCULOM
                                                         AND MAX_ALTESITUFUNC.NRORG = GPE_ALTESITUFUNC.NRORG
                                                         AND MAX_ALTESITUFUNC.NRSITUFUNCM <> 12
                                                         AND MAX_ALTESITUFUNC.DTINISITUFUNC <= LAST_DAY(:DTMESCOMPETENC))

            LEFT JOIN GPE_SITUFUNCM
                ON GPE_SITUFUNCM.NRSITUFUNCM = GPE_ALTESITUFUNC.NRSITUFUNCM
                AND (GPE_SITUFUNCM.NRORG = GPE_ALTESITUFUNC.NRORG OR GPE_SITUFUNCM.NRORG = :NRORG_PADRAO OR GPE_SITUFUNCM.NRORG IS NULL)
            LEFT JOIN GPE_SITUFUNCH
                ON GPE_SITUFUNCH.NRSITUFUNCM = GPE_SITUFUNCM.NRSITUFUNCM
                AND (GPE_SITUFUNCH.NRORG = GPE_SITUFUNCM.NRORG OR GPE_SITUFUNCH.NRORG = :NRORG_PADRAO OR GPE_SITUFUNCH.NRORG IS NULL)
                AND GPE_SITUFUNCH.DTEFETIVA = (SELECT MAX(MAX_SITUFUNCH.DTEFETIVA)
                                                 FROM GPE_SITUFUNCH MAX_SITUFUNCH
                                                WHERE MAX_SITUFUNCH.NRSITUFUNCM = GPE_SITUFUNCH.NRSITUFUNCM
                                                  AND MAX_SITUFUNCH.DTEFETIVA <= :DTMESCOMPETENC)
            
            /* COMPETÊNCIA A PARTIR DO NÚMERO DE CÁLCULO */
            LEFT JOIN FPA_CALCULOFOLHA CF ON CF.NRCALCULOFOLHA = :NRCALCULOFOLHA
            AND CF.NRORG = VAB_BENEFICIOM.NRORG


       WHERE VAB_BENEFICIOM.NRORG         = :NRORG
               
               /* FILTRO DE VÍNCULOS ATIVOS/RESCINDIDOS/TODOS */
               AND (
                    (
                        (
                            GPE_VINCULOM.DTRESCISAOVINC IS NOT NULL 
                            OR GPE_VINCULOM.DTRESCISAOVINC < :PROXCOMPETENC
                        ) 
                        AND :RESCISAO = 'R'
                    ) 
                    OR (
                        (
                            GPE_VINCULOM.DTRESCISAOVINC IS NULL 
                            OR GPE_VINCULOM.DTRESCISAOVINC >= :DTMESCOMPETENC
                        ) 
                        AND :RESCISAO = 'A'
                    ) 
                    OR :RESCISAO = 'T'
                )                


               /* FILTRO DE BENEFICIOS ATIVOS/NÃO ATIVOS/TODOS */
               AND ( 

                        ( VAB_BENEFICIOM.IDATIVO = 'S' AND :IDATIVBENEFICIO = 'A' )
                    OR  ( VAB_BENEFICIOM.IDATIVO = 'N' AND :IDATIVBENEFICIO = 'N' )
                    OR  :IDATIVBENEFICIO = 'T'
                )
                

               /* FILTRO DE BENEFICIÁRIOS ATIVOS/NÃO ATIVOS/TODOS */
               AND (
                    (
                        (
                            VAB_BENEFICIARIO.DTCANCBENEFICIARIO IS NOT NULL 
                            OR VAB_BENEFICIARIO.DTCANCBENEFICIARIO <= :DTMESCOMPETENC
                        ) 
                        AND :IDATIVBENEFICIARIO = 'N'
                    ) 
                    OR (
                        (
                            VAB_BENEFICIARIO.DTCANCBENEFICIARIO IS NULL 
                            OR VAB_BENEFICIARIO.DTCANCBENEFICIARIO > :DTMESCOMPETENC
                        ) 
                        AND :IDATIVBENEFICIARIO = 'A'
                    ) 
                    OR :IDATIVBENEFICIARIO = 'T'
                )                

         $condEstrutLegal
         $condEstrutGeren
         AND (INSTR(:NRESTRUTLEGAL_LIST, '_'||GPE_VINCULOH.NRESTRUTLEGAL||'_') > 0 OR :NRESTRUTLEGAL_LIST = 'A')
         AND (INSTR(:NRESTRUTGEREN_LIST, '_'||GPE_VINCULOH.NRESTRUTGEREN||'_') > 0 OR :NRESTRUTGEREN_LIST = 'A')
         AND (INSTR(:NRESTRUTSIND_LIST, '_'||GPE_VINCULOH.NRESTRUTSIND||'_') > 0 OR :NRESTRUTSIND_LIST = 'A')
         AND (INSTR(:NRBENEFICIOM_LIST, '_'||VAB_BENEFICIOM.NRBENEFICIOM||'_') > 0 OR :NRBENEFICIOM_LIST = 'A')
         AND (INSTR(:NRTPBENEFICIO_LIST, '_'||VAB_BENEFICIOH.NRTPBENEFICIO||'_') > 0 OR :NRTPBENEFICIO_LIST = 'A')
         AND (INSTR(:NRVINCULOM_LIST, '_'||GPE_VINCULOM.NRVINCULOM||'_') > 0 OR :NRVINCULOM_LIST = 'A')
         AND (CONTCORRPARC.NRCONTCORRPARC = ( SELECT MAX(NRCONTCORRPARC) NRCONTCORRPARC
                                                FROM CONTCORRPARC C
                                               WHERE NRORG         = GPE_PESSOA.NRORG
                                                 AND NRPARCNEGOCIO = GPE_PESSOA.NRPARCNEGOCIO) or CONTCORRPARC.NRCONTCORRPARC IS NULL )
      ORDER BY VAB_BENEFICIOH.DSBENEFICIO, GPE_VINCULOM.NMVINCULOM, PES_BENEFICIARIO.NMPESSOA 
     )
 WHERE 1=1 $conditions $listaVinc $buttonFloatingSearch";

        $params = [
                    "DTMESCOMPETENC"     => $dtcompetencia,
                    "NRORG"              => $nrorg,
                    "NRORG_PADRAO"       => $nrorgPadrao,                    
                    "NRCALCULOFOLHA"     => $nrcalculobenef,
                    "PROXCOMPETENC"      => $proxCompetencia,
                    "RESCISAO"           => $condRescisaoVinc,
                    "IDATIVBENEFICIO"    => $condAtivacaoBeneficio,
                    "IDATIVBENEFICIARIO" => $condAtivacaoBeneficiario,
                    "NRESTRUTLEGAL_LIST" => $condListaEstrutLegal,
                    "NRESTRUTGEREN_LIST" => $condListaEstrutGeren,
                    "NRESTRUTSIND_LIST"  => $condListaEstrutSind,
                    "NRBENEFICIOM_LIST"  => $condListaBeneficio,
                    "NRTPBENEFICIO_LIST" => $condListaTpBeneficio,
                    "NRVINCULOM_LIST"    => $condListaVinculo
                  ];
        
        return $this->connection->fetchAll($sql, $params);
    }    
    
    public function retornaRelatEscala($dtcompetencia, $dtinicontagem, $nrorg, $nrvinculom, $conditions, $where){
        $sql = "
SELECT * FROM (        
    SELECT
      VM.NMVINCULOM,    
      VH.NRESTRUTLEGAL,
      VH.NRESTRUTGEREN,
      AE.NRVINCULOM,
      AE.NRTURNO,
      ETH.NMESCALATRABH,
      DT.DTDATA DATA,
      DECODE(MOD(HT.NRSEQHORARIO, 7), 1, 'Sábado',
                                      2, 'Domingo',
                                      3, 'Segunda',
                                      4, 'Terça',
                                      5, 'Quarta',
                                      6, 'Quinta',
                                      0, 'Sexta') DIASEMANA,
      HDH.NMHORDIAH,
      ETH.QTHRSEMENAGEREN QDE_HORAS_DIA,
      ETH.QTHRSEMESCTRABH QDE_HORAS_SEM    
    FROM GPE_ALTEESCALA AE
    /*Nome do Vinculo*/
    JOIN GPE_VINCULOM VM ON AE.NRVINCULOM = VM.NRVINCULOM
                         AND AE.NRORG = VM.NRORG
    /*Para filtro de Estrutura Legal e Gerencial*/
    JOIN GPE_VINCULOH VH ON VH.NRVINCULOM      = VM.NRVINCULOM
                         AND VH.NRORG          = VM.NRORG
                         AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH VHH
                                                  WHERE VHH.NRVINCULOM    = VH.NRVINCULOM
                                                    AND VHH.NRORG           = VH.NRORG
                                                    AND VHH.DTMESCOMPETENC <= :P_COMPETENCIA )
    
    /*Escala de Trabalho*/
    JOIN GPE_ESCALATRABH ETH ON ETH.NRORG         = AE.NRORG
                            AND ETH.NRESCALATRABM = AE.NRESCALATRABM
                            AND ETH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_ESCALATRABH
                                                       WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                         AND NRORG         = ETH.NRORG
                                                         AND NRESCALATRABM = ETH.NRESCALATRABM )
    /*Datas*/
    JOIN DATA DT ON DT.DTDATA BETWEEN             TO_DATE( :P_DIA )
                                  AND ADD_MONTHS( TO_DATE( :P_DIA ), 1 ) - 1 
                                  AND DT.DTDATA <= NVL(VM.DTRESCISAOVINC, DT.DTDATA)
                                  AND DT.DTDATA >= NVL(VM.DTADMISSAOVINC, DT.DTDATA)
    /*Turno e horários*/
    JOIN ( SELECT MAX(NRSEQHORARIO) NRSEQHORARIO, NRTURNO /*Adquiri o max do NRSEQHORARIO do turno em questão*/
           FROM GPE_HORARIOTURNO
           WHERE NRORG        = :P_NRORG
             AND IDATIVO      = 'S'
           GROUP BY NRTURNO ) AUX ON AUX.NRTURNO = AE.NRTURNO
    JOIN GPE_HORARIOTURNO HT ON HT.NRORG        = AE.NRORG
                            AND HT.NRTURNO      = AE.NRTURNO
                            AND HT.IDATIVO      = 'S'
                            AND HT.NRSEQHORARIO = NVL( NULLIF( MOD( TO_CHAR( DT.DTDATA - 4, 'J' ), AUX.NRSEQHORARIO ), 0 ), AUX.NRSEQHORARIO )
    JOIN GPE_HORDIAH HDH ON HDH.NRORG          = AE.NRORG 
                        AND HDH.NRHORDIAM      = HT.NRHORDIAM
                        AND HDH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_HORDIAH
                                                   WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                     AND NRORG     = HDH.NRORG 
                                                     AND NRHORDIAM = HDH.NRHORDIAM )
    /**/
    WHERE AE.NRORG       = :P_NRORG
      AND ( AE.NRVINCULOM  = :P_VINCULO OR :P_VINCULO IS NULL ) 
      AND AE.DTINIESCALA = ( SELECT MAX(DTINIESCALA) FROM GPE_ALTEESCALA
                             WHERE DTINIESCALA <= LAST_DAY(:P_COMPETENCIA)
                               AND NRORG                = AE.NRORG
                               AND NRVINCULOM   = AE.NRVINCULOM )
      AND ( VM.DTRESCISAOVINC >= :P_COMPETENCIA OR VM.DTRESCISAOVINC IS NULL )
     $where
    
    ORDER BY VM.NMVINCULOM, DT.DTDATA
 )
 WHERE 1=1 $conditions
"
;

        $params = [
                    "P_DIA"            => $dtinicontagem,
                    "P_NRORG"          => $nrorg,
                    "P_VINCULO"        => $nrvinculom,  
                    "P_COMPETENCIA"    => $dtcompetencia,
                  ];

        $retorno = $this->connection->fetchAll($sql, $params);
        
        return $retorno;
    }
} 